// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

// Properties set by attributes panel
var numItemsToShow;         // Max number of items to display; -1 = all
var maxAgeToShow;           // Max age in days; 0 = today, -1 = all
var showDate;               // Whether to show the article dates
var feed = { url: null, title: "", baseURL: null };  // Object to hold information about the current feed
var lastUpdated = 0;                                 // Track last refresh time to avoid excessive updates
var lastResults = null;                              // Previous feed contents
var httpFeedRequest = null;                          // The current XMLHttpRequest
var loadingAnimationTimer = null;                    // Updates the "Loading..." animation's dots
var filterString = "";                               // String to filter results while searching
var slider;                                          // Article length slider element on the back
var recentPage = 1;
var scrollArea;
var searchString = "";
var lastButton = "";
var currentButton = "recent";
var popularDays = 90;
var allowedDays = {7: 'Week', 30: 'Month', 90: '3 Months', 180: '6 Months', 365: 'Year', 0: 'All'}; 
var numItems = 0;
var itemsPerPage = 10;

//	Let's specify a couple extra feeds for thinks like pages, searching and popular items
var altRecentFeed = {url: 'http://www.mactips.org/wp-special-rss2.php', title: 'Recent Feed', baseURL: ''};
var popularFeed = {url: 'http://www.mactips.org/wp-pop-rss2.php', title: 'Popular Fleed', baseURL: ''};

// Define some namespaces commonly used in feeds
var NS_DC = "http://purl.org/dc/elements/1.1/";
var NS_CONTENT = "http://purl.org/rss/1.0/modules/content/";
var NS_XHTML = "http://www.w3.org/1999/xhtml";

var x;
var y;

//
// Function: refreshFeed()
// Starts loading the feed source.
// processFeedDocument() will be called when it finishes loading.
//
function refreshFeed()
{
    if (!feed.url || feed.url.length < 1) {
        showMessageInContents(getLocalizedString("No Feed Specified"),
            getLocalizedString("Please specify a valid feed URL."));
        return false;
    }

    showLoadingMessage();

    // Abort any pending request before starting a new one
    if (httpFeedRequest != null) {
        httpFeedRequest.abort();
        httpFeedRequest = null;
    }
    httpFeedRequest = new XMLHttpRequest();

    // Function callback when feed is loaded
    httpFeedRequest.onload = function (e)
    {
        var feedRootElement;
        if (httpFeedRequest.responseXML) feedRootElement = httpFeedRequest.responseXML.documentElement;

        // Request is no longer pending
        httpFeedRequest = null;

        // Process the loaded document
        processFeedDocument(feedRootElement);
    }

    httpFeedRequest.overrideMimeType("text/xml");
    httpFeedRequest.open("GET", feed.url);
    httpFeedRequest.setRequestHeader("Cache-Control", "no-cache");

    // Send the request asynchronously
    httpFeedRequest.send(null);
}

//
// Function: processFeedDocument(doc)
// When the feed finishes loading, this function is called to parse it and display the results.
//
// doc: XML document containing the feed
//
function processFeedDocument(doc)
{
    hideLoadingMessage();

    if (doc) {
        // Remove the old entries
        clearContent();

        // Determine the feed type and call the appropriate parser
        var results = '';

        // It's probably some version of RSS.
        // We don't care as long as it has <item>s
        results = parseRSSFeed(doc);
        

        // Got no results?
        if (results == null || results.length < 1) {
            showMessageInContents(getLocalizedString("No Items Found"),
				"Your search came up empty, <a href='#' onclick='clearSearch();'>clear search</a>.");

            return;
        }
		
        // Save unfiltered results
        lastResults = results;

        // Generate the display
        addEntriesToContents(results);

        // update the scrollbar so scrollbar matches new data
        refreshScrollArea();

        // Show new item indicator if necessary
        if (attributes.showUpdateBadge == 1) {
            checkNewItems(lastResults, results);
        }

        // set lastUpdated to the current time to keep track of the last time a request was posted
        lastUpdated = (new Date).getTime();
    }
    else {
        // document is empty
        showMessageInContents(getLocalizedString("Invalid Feed"),
                              getLocalizedString("%s does not appear to be a valid RSS or Atom feed.").replace("%s", feed.url));
    }
}

//
//	clearSearch
//
//	Reset the search field and refresh results
function clearSearch() {
	document.getElementById('searchInput').value = '';
	searchString	= '';
	recentPage		= 1;
	
	goToPage();
	
}

//
// Function: parseAtomFeed(atom)
// Parse an Atom feed.
//
// atom: Atom feed as an XML document.
//
// Returns the parsed results array.
//
function parseAtomFeed(atom)
{
    // Check for a global base URL
    var base = atom.getAttribute("xml:base");
    if (base) {
        feed.baseURL = splitURL(base);
    }

    var results = new Array;

    // For each element, get title, link and publication date.
    // Note that all elements of an item are optional.
    for (var item = atom.firstChild; item != null; item = item.nextSibling) {
        if (item.nodeName == "entry") {
            var title = atomTextToHTML(findChild(item, "title"));

            // we have to have the title to include the item in the list
            if (title) {
                // Just get the first link for now - Atom is complicated
                var link;
                var linkElement = findChild(item, "link");
                if (linkElement) {
                    link = linkElement.getAttribute("href");
                }

                // Try a few different ways to find a date
                var dateEl = findChild(item, "updated")
                    || findChild(item, "issued") 
                    || findChild(item, "modified")
                    || findChild(item, "created");
                var itemDate = parseDate(allData(dateEl));

                var description;
                var descElt = findChild(item, "content") || findChild(item, "summary");
                if (descElt) {
                    description = atomTextToHTML(descElt);
                }

                results[results.length] = {
                    title: title,
                    link: link,
                    date: itemDate,
                    description: description
                }
            }
        }
    }

    return results;
}

//
// Function: parseRSSFeed(rss)
// Parse an RSS feed.
//
// rss: RSS feed as an XML document.
//
// Returns the parsed results array.
//
function parseRSSFeed(rss)
{
    var results = new Array;

    // Get global <link> element as base url
    var channel = findChild(rss, "channel");
    if (channel) {
        var mainLinkEl = findChild(channel, "link");
        if (mainLinkEl) {
            feed.baseURL = splitURL(allData(mainLinkEl));
        }
		
		numItems = allData(findChild(channel, "numItems"));

    }

    // Get all item elements.
    // For each element, get title, link and publication date.
    // Note that all elements of an item are optional.
    var items = rss.getElementsByTagName("item");
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
        if (item.nodeName == "item") {
            var title = findChild(item, "title");

            // we have to have the title to include the item in the list
            if (title != null) {
                // get the link
                var link = findChild(item, "link");
                // get the date
                var dateEl = findChild(item, "pubDate") || findChild(item, "date", NS_DC);
                var itemDate = parseDate(allData(dateEl));
                // get the description
                var description = findChild(item, "encoded", NS_CONTENT) || findChild(item, "description");
                // save the result
                results[results.length] = {
                    title: allData(title),
                    link: allData(link),
                    date: itemDate,
                    description: allData(description)
                }
            }
        }
    }

    return results;
}

//
// Function: splitURL(url)
// Split components of the URL (protocol, domain, resource)
//
// url: URL to split
//
function splitURL(url)
{
    var baseURL = { protocol: "", domain: "", resource: "" };
    if (!url || url.length < 1) {
        return baseURL;
    }

    var components = url.split("://");
    baseURL.protocol = components[0];
    var slashIndex = components[1].indexOf("/");
    if (slashIndex >= 0) {
        baseURL.domain = components[1].substring(0, slashIndex);
        baseURL.resource = components[1].substring(slashIndex + 1, components[1].length);
    }
    else {
        baseURL.domain = components[1];
    }

    return baseURL;
}

//
// Function: checkNewItems(oldResults, newResults)
// Determine how many new items have appeared since the last refresh.
//
// oldResults: Previously saved items for comparison.
// newResults: Array to search for new items.
//
function checkNewItems(oldResults, newResults)
{
    if (oldResults == null) {
        // Just starting up, so everything is new, and no need to say so.
        return;
    }

    if (oldResults.length == 0) {
        // If there are no old items, then all the new items are new
        if (newResults.length != 0) {
            // (If there are any)
            showNewCount(newResults.length);
            return;
        }
    }

    // Count the new items
    var newCount = 0;

    // Compare the last old item to the new items
    var oldItem = oldResults[0];
    for (var n = 0; n < newResults.length; n++) {
        var newItem = newResults[n];
        // Use the dates, if we're lucky enough to have them
        if (oldItem.date && newItem.date) {
            if (newItem.date > oldItem.date) {
                newCount++;
            }
            else {
                // Hit the end of the new stuff, so exit the loop
                break;
            }
        }
        else {
            // No date, so compare the titles
            if (newItem.title != oldItem.title) {
                newCount++;
            }
            else {
                // We've seen this title before, so exit the loop
                break;
            }
        }
    }

    if (newCount > 0) {
        showNewCount(newCount);
    }
}

//
// Function: createRow(title, link, date, description, index)
// Generate a new row for the content area.
//
// title: Article's title.
// link: Article's link.
// date: Article's date.
// description: Article's description.
// index: Row number for even/odd hilighting.
//
// Returns the created DIV element
//
function createRow(title, link, date, description, index)
{
    // create a DIV for the article
    var article = document.createElement("div");
    article.setAttribute("class", "article " + (index % 2 ? "even" : "odd"));
    // if it is not the first article, include a separation line
    if (index > 0) {
        var articleseparator = document.createElement("div");
        articleseparator.setAttribute("class", "articleseparator");
        article.appendChild(articleseparator);
    }

    // optionally, make the title a link
    var articlehead;
    if (link && link.length) {
        // if it is a relative link, make it absolute
        if (link.indexOf(":") < 0) link = absoluteURL(link);
        // set the link
        articlehead = document.createElement("a");
        articlehead.setAttribute("href", link);
    }
    else {
        articlehead = document.createElement("span");
    }
    articlehead.setAttribute("class", "articlehead");

    // title of the article
    var subjectElt = makeEntryDiv(title);
    subjectElt.setAttribute("class", "subject");
    articlehead.appendChild(subjectElt);

    // date of the article
    if (date != null && !isNaN(date.valueOf())) {
        var dateDiv = document.createElement("div");
        dateDiv.setAttribute ("class", "date");
        if (showDate) {
            dateDiv.innerText = createDateStr(date);
        }

        articlehead.appendChild(dateDiv);
    }

    article.appendChild(articlehead);

    // main body of the article
    if (description != null) {
        var descElt = makeEntryDiv(description);
        descElt.setAttribute("class", "articlebody");

        article.appendChild(descElt);
    }

    fixLinks(article);

    return article;
}

//	
//	popularDaysTextToNum
//
//	Converts the text to a number
function popularDaysTextToNum(dayText) {
	var day = -1;
	for (currDay in allowedDays) {
		if (allowedDays[currDay] == dayText) {
			day = currDay;
			break;
		}
	}
	return day;
}

//
// Function: makeEntryDiv(content)
// Formats an entry's content as a div for display
//
// content: string or element containing an entry
//
function makeEntryDiv(content)
{
    var div;

    if (typeof content == "string") {
        // If it's a plain string, wrap it in a div
        div = document.createElement("div");
        div.innerHTML = content;
    }
    else {
        div = content;
    }

    return div;
}

//
// Function: addEntriesToContents(entries)
// Take the parsed results and display them in the content area.
//
// entries: Array of items to display.
//
function addEntriesToContents(entries)
{
	if (getToggle() == 'popular') {
		displayPopularDays();
	}
	
    // copy title and date into rows for display. Store link so it can be used when user
    // clicks on title
    nItems = entries.length

    var contentElement = document.getElementById("content");
    for (var i = 0; i < nItems; ++i) {
        var item = entries[i];
        var row = createRow(item.title, item.link, item.date, item.description, i);

        contentElement.appendChild(row);
    }
	
	displayPagination();
	loadLinkEffects();
	
}

//
//	displayPopularDays()
//
//	Display a set of popular links at the top of a post
//
function displayPopularDays() {
	var contentElement = document.getElementById("content");
	
	var popularDaysArea	= document.createElement("div");
	
	popularDaysArea.innerHTML = 'Past:';
	
	popularDaysArea.setAttribute("id", "popular-days-area");

	for (day in allowedDays) {
		var dayText = allowedDays[day];
		
		var dayLink = document.createElement("a");
		
		if (day == popularDays) {
			dayLink.setAttribute("class", "active");
		}

		dayLink.innerText	= dayText;
		dayLink.onclick		= function() { switchPopularDay(this.innerText) }
		dayLink.href		= '#';
		
		popularDaysArea.appendChild(dayLink);
		
	}
	
	contentElement.appendChild(popularDaysArea);
	
}

//
//	switchPopularDay()
//
//	Switch the popular days variable and class
//
function switchPopularDay(dayText) {
	day = popularDaysTextToNum(dayText);
	
	//	As long as we found a match, continue
	if (day != -1) {
		popularDays = day;
		recentPage = 1;
		widget.setPreferenceForKey(dayText, 'popular_days');
		
		enableActivePopularDaysLink(dayText);
		goToPopularPage();
	}
}

//
//	enableActivePopularDaysLink()
//
//	Set the current popular days link to active
function enableActivePopularDaysLink(dayText) {
	//	Now let's loop through and add the correct class to the active link
	var popularDaysArea = document.getElementById('popular-days-area');
	
	var popularDaysLinks = popularDaysArea.getElementsByTagName("a");
	for (var i = 0; i < popularDaysLinks.length; i++) {
		if (popularDaysLinks[i].innerHTML == dayText) {
			popularDaysLinks[i].setAttribute("class", "active");
		} else {
			popularDaysLinks[i].setAttribute("class", "");
		}
	}
}


//
//	displayPagination()
//
//	Display page buttons for the recent or popular tab
function displayPagination() {
	
    var contentElement = document.getElementById("content");
	
	if ((recentPage * itemsPerPage) < numItems
		|| (attributes.feedURL == feed.url)) {
		var prevEntries = document.createElement("a");
		prevEntries.setAttribute("class", "pageLeft");
		prevEntries.innerText	= 'Previous';
		prevEntries.onclick		= function() { recentPage++; goToPage() }
		prevEntries.href		= '#';
	
		contentElement.appendChild(prevEntries);
	}
		
	//	If we're in previous posts, allow the next button
	if (recentPage > 1) {
		var nextEntries = document.createElement("a");
		nextEntries.setAttribute("class", "pageRight");
		nextEntries.innerText	= 'Next';
		nextEntries.onclick		= function() { recentPage--; goToPage() }
		nextEntries.href		= '#';
		
		contentElement.appendChild(nextEntries);
	}

}

//
//	goToPage()
//
//	Simple function to go to the correct page
//	when we click next or previous
//
function goToPage() {
	if (getToggle() == 'recent') {
		goToRecentPage();
	} else {
		goToPopularPage();
	}
}

//
//	goToRecentPage()
//
//	Go to page x in recent pages
//
function goToRecentPage() {
		//	If everything is default we're going to switch the feed over to the
		//	default one so we can try and get some tracking statistics from FeedBurner
		if (recentPage == 1 && searchString == '') {
			setFeedSource(attributes.feedURL);
		} else {
			setFeedSource(altRecentFeed.url + "?paged=" + recentPage + "&s=" + searchString);
		}
		refreshFeed();
		scrollArea.verticalScrollTo(0);
}

//
//	goToPopularPage()
//
//	Go to page x in popular pages
//
function goToPopularPage() {
    setFeedSource(popularFeed.url + "?paged=" + recentPage + "&s=" + searchString + "&days=" + popularDays);
	refreshFeed();
	scrollArea.verticalScrollTo(0);

}


//
//	search()
//
//	Search the RSS feed
function search(string) {
	searchString	= string;
	recentPage		= 1;
	
	goToPage();
}


//
// Function: clearContent()
// Clear the current content area.
//
function clearContent()
{
    var content = document.getElementById("content");

    if (content) {
        while (content.hasChildNodes()) {
            content.removeChild(content.firstChild);
        }
    }
}

//
// Function: showMessageInContents(title, message)
// Display a status or error message in the content area.
//
// title: Title of message to display.
// message: Message text to display.
//
function showMessageInContents(title, message)
{
    clearContent();
	
	var errorElement = document.createElement("div");
	errorElement.setAttribute("class", "error");
	
    var titleElement = document.createElement("div");
    titleElement.setAttribute("class", "message-title");
    titleElement.innerText = title;

    var messageElement = document.createElement("div");
    messageElement.setAttribute("class", "message-body");
    messageElement.innerHTML = message;

    var contentElement = document.getElementById("content");
    errorElement.appendChild(titleElement);
    errorElement.appendChild(messageElement);
	
	contentElement.appendChild(errorElement);

    refreshScrollArea();
}

//
// Function: showNewCount(newCount)
// Display a new-items indicator.
//
// newCount: Count of new items to display.
//
function showNewCount(newCount)
{
    setLoadingText(getLocalizedString("%s new").replace("%s", newCount));
}

//
// Function: showLoadingMessage()
// Display "Loading..." and start the dots animating.
//
function showLoadingMessage()
{
	clearContent();
    showElement("loading-text");
}

//
// Function: hideLoadingMessage()
// Stop and remove the "Loading..." animation.
//
function hideLoadingMessage()
{
    hideElement("loading-text");
}

//
// Function: setLoadingText(loadingText)
// Display a message in the "Loading" area.
//
// loadingText: Text to display.
//
function setLoadingText(loadingText)
{
    var loadingElement = document.getElementById("loading-text");
    if (loadingElement) {
        loadingElement.innerText = loadingText;
        showElement("loading-text");
    }
}

//
// Function: startLoadingAnimation()
// Places animated "Loading..." text on the widget while the feed loads.
//
function startLoadingAnimation()
{
    var dots = 0;
    var animateLoadingDots = function ()
    {
        var loading = getLocalizedString("Loading");
        for (var i = 0; i < dots; i++) {
            loading = loading + ".";
        }
        setLoadingText(loading);

        if (++dots > 3) {
            dots = 0;
        }
    };

    animateLoadingDots();
    loadingAnimationTimer = setInterval(animateLoadingDots, 500);
}

//
// Function: stopLoadingAnimation()
// Stop the "Loading..." animation.
//
function stopLoadingAnimation()
{
    if (loadingAnimationTimer != null) {
        clearInterval(loadingAnimationTimer);
        loadingAnimationTimer = null;
    }
}

//
// Function: fixLinks(htmlFragment)
// Update hyperlinks in a document fragment to use the openURL function.
//
// htmlFragment: DOM element in which to adjust links.
//
function fixLinks(htmlFragment)
{
    // Collect all the links
    var links = htmlFragment.getElementsByTagName("a");
    for (var i = 0; i < links.length; i++) {
        var aNode = links[i];
        var href = aNode.getAttribute("href");
        // Make it absolute if it isn't already
        if (href && href.indexOf(":") < 0) {
            aNode.setAttribute("href", absoluteURL(href));
        }

        // Send them to our clickOnLink function
        aNode.addEventListener("click", clickOnLink, false);
    }
	
	//	Collect all images
	var images = htmlFragment.getElementsByTagName("img");
	for (var n = 0; n < images.length; n++) {
		var aNode = images[n];
        var href = aNode.getAttribute("src");
        // Make it absolute if it isn't already
        if (href && href.indexOf(":") < 0) {
            aNode.setAttribute("src", absoluteURL(href));
        }
	}
}


//
// Function: parseDate(dateToParse)
// Parse a date string in several formats into a Date object
//
// dateToParse: String containing a date.
//
// Returns a Date object containing the parsed date.
//
function parseDate(dateToParse)
{
    var returnDate = null;
    if (!dateToParse || dateToParse.length < 1) {
        return null;
    }
    
    // try to parse as date string
    returnDate = new Date(dateToParse);

    // if no success, try other formats
    if ((!returnDate || isNaN(returnDate.valueOf()))) {
        var dateTimeSeparator = null;
        var monthIndex = null;
        var dayIndex = null;
        var yearIndex = null;
        // try ISO 8601 format (YYYY-MM-DDTHH:MM:SS+OO:OO)
        if (dateToParse.match(/^\d\d\d\d-\d\d-\d\d/)) {
            dateTimeSeparator = "T";
            monthIndex = 1;
            dayIndex = 2;
            yearIndex = 0;
        }
        // try other format (MM-DD-YYYY HH:MM:SS)
        else if (dateToParse.match(/^\d\d-\d\d-\d\d\d\d/)) {
            dateTimeSeparator = " ";
            monthIndex = 0;
            dayIndex = 1;
            yearIndex = 2;
        }
        
        // if the date format was recognized, parse it
        if (dateTimeSeparator) {
            returnDate = new Date();
            // separate date and time
            var dateTime=dateToParse.split(dateTimeSeparator);

            // set the date
            var dateArray = dateTime[0].split("-");
            if (dateArray[monthIndex]) returnDate.setMonth(dateArray[monthIndex]-1);
            if (dateArray[dayIndex]) returnDate.setDate(dateArray[dayIndex]);
            if (dateArray[yearIndex]) returnDate.setYear(dateArray[yearIndex]);

            // split time and offset
            var timeArray = null;
            if (dateTime[1]) timeArray = dateTime[1].match(/(\d\d):(\d\d):(\d\d)(?:\.\d+)?(?:([+-])(\d\d):(\d\d))?/);
            if (timeArray) {
                // set the time
                if (timeArray[1]) returnDate.setHours(timeArray[1]);
                if (timeArray[2]) returnDate.setMinutes(timeArray[2]);
                if (timeArray[3]) returnDate.setSeconds(timeArray[3]);

                // add the offset
                if (timeArray[4] && timeArray[5]) {
                    var time = returnDate.getTime() - returnDate.getTimezoneOffset() * 60000;
                    if (timeArray[4] == "+")
                        time -= timeArray[5] * 3600000;
                    else
                        time += timeArray[5] * 3600000;
                    returnDate.setTime(time);
                }
            }
        }
    }

    // if no success, return null
    if (returnDate && isNaN(returnDate.valueOf())) {
        returnDate = null;
    }

    return returnDate;
}

//
// Function: findChild(element, nodeName, namespace)
// Scans the children of a given DOM element for a node matching nodeName, optionally in a given namespace.
//
// element: The DOM element to search.
// nodeName: The node name to search for.
// namespace: Optional namespace the node name must be in.
//
// Returns the child node if found, otherwise null.
//
function findChild(element, nodeName, namespace)
{
    var child;

    for (child = element.firstChild; child != null; child = child.nextSibling) {
        if (child.localName == nodeName) {
            if (namespace == null || child.namespaceURI == namespace)
                return child;
        }
    }

    return null;
}

//
// Function: allData(node)
// Concatenate all the text data of a node's children.
//
// node: DOM element to search for text.
//
// Returns the concatenated text.
//
function allData(node)
{
    var data = "";
    if (node && node.firstChild) {
        node = node.firstChild;
        if (node.data) data += node.data;
        while (node = node.nextSibling) {
            if (node.data) data += node.data;
        }
    }

    return data;
}

//
// Function: absoluteURL(url)
// Convert a relative URL into an absolute one using the feed's base URL
//
// url: Relative URL to convert.
//
// Returns the absolute URL.
//
function absoluteURL(url)
{
    if (!feed.baseURL) {
        return url;
    }

    var baseURL = feed.baseURL.protocol + "://" + feed.baseURL.domain;
    // if it is absolute within the domain
    if (url.indexOf("/") == 0) url = baseURL + url;
    // if it is relative to the current resorce
    else url = baseURL + "/" + feed.baseURL.resource + url;
    return url;
}

//
// Function: createDateStr(date)
// Generate a date label from a JavaScript date.
//
// date: JavaScript date object
//
// Returns a string containing the short date.
//
function createDateStr(date)
{
    var month;
    switch (date.getMonth()) {
        case 0: month = "Jan"; break;
        case 1: month = "Feb"; break;
        case 2: month = "Mar"; break;
        case 3: month = "Apr"; break;
        case 4: month = "May"; break;
        case 5: month = "Jun"; break;
        case 6: month = "Jul"; break;
        case 7: month = "Aug"; break;
        case 8: month = "Sep"; break;
        case 9: month = "Oct"; break;
        case 10: month = "Nov"; break;
        case 11: month = "Dec"; break;
    }
    return month + " " + date.getDate();
}


//
// Function: clickOnLink()
// Called from onClick to open a link in the browser instead of in the widget.
//
function clickOnLink(e)
{
    if (window.widget) {
        widget.openURL(this.href);
        if (e) {
            e.stopPropagation();
            e.preventDefault();
        }
        return false;
    }
}

//
// Function: clickOnBottomRectangle(event)
// For testing, refresh the feed on option-clicking the bottom border.
//
// event: onClick event from widget.
//
function clickOnBottomRectangle(event)
{
    if (event.altKey) {
        refreshFeed();
    }
}

//
// Function: scaleArticles(value)
// Called by the article length slider.  Updates CSS to truncate articles.
//
// value: Percentage value from the slider.
//
function scaleArticles(value)
{
    var contentElement = document.getElementById("content");
    contentElement.style.appleLineClamp = value + "%";
}

//
// Function: scaleTo(value)
// Called by the article length max and min buttons. Update slider and scale articles.
//
// value: Percentage value to set the scale to.
//
function scaleTo(value)
{
    slider.value = value;
    scaleArticles( value );
}

//
// Function: scaleToMin()
// Called by the article length slider's minimum button.
//
function scaleToMin()
{
    scaleTo( slider.getAttribute("min") );
}

//
// Function: scaleToMax()
// Called by the article length slider's maximum button.
//
function scaleToMax()
{
    scaleTo( slider.getAttribute("max") );
}

//
// Function: refreshScrollArea()
// Updates the content areas's scroll bar when the content or article length has changed.
//
function refreshScrollArea()
{
    var contentarea = document.getElementById("contentarea");
    if (contentarea) contentarea.object.refresh();
}

//
// Function: hideElement(elementId)
// Turn off display for the given element.
//
// elementId: DOM id of the element to hide.
//
function hideElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element)
        element.style.display = "none";
}

//
// Function: showElement(elementId)
// Turn on display for the given element.
//
// elementId: DOM id of the element to show.
//
function showElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element)
        element.style.display = "block";
}

//
// Function: setFeedSource()
// Set the URL from where to get the feed.
//
// url: URL of the feed source
//
function setFeedSource(url) {
    if (url) {
        // make sure the url has an appropriate protocol
        url = url.replace(/^(feed:\/\/)/, "http://");
        if (url.indexOf("://") < 0) {
            url = "http://" + url;
        }
    }
    feed.url = url;
    feed.baseURL = splitURL(url);
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	
//    CreateInfoButton('info', { frontID: 'front', foregroundStyle: 'white', backgroundStyle: 'black', onclick: 'showBack' });
    CreateGlassButton('done', { text: 'Done', onclick: 'showFront' });

	flipper = new AppleInfoButton(document.getElementById('flipper'),
					document.getElementById('front'), 'black', 'black', showBack);

    scrollArea  = CreateScrollArea('contentarea', { spacing: 11, leftMargin: 11, rightMargin: 7,							hasVerticalScrollbar: true,
						autoHideScrollbars: true, scrollbarMargin: 6, scrollbarDivSize: 18 });

	numItemsToShow = +attributes.numItemsToShow;
    maxAgeToShow   = +attributes.maxAgeToShow;
    showDate       = attributes.showDate == 1;
	
	if (widget.preferenceForKey('popular_days')) {
		popularDays = popularDaysTextToNum(widget.preferenceForKey('popular_days'));
		if (popularDays == -1) { popularDays = 90; }
	} else {
		widget.setPreferenceForKey(popularDays, 'popular_days');
	}
	
	var dimensions = widget.preferenceForKey('dimensions');
	if (dimensions) {
		dimensions = dimensions.split("x");
		resizeWidget(dimensions[0], dimensions[1]);
	} else {
		widget.setPreferenceForKey('490x340', 'dimensions');
	}
	
	toggleButtons();

    slider = document.getElementById("slider");
    scaleArticles(slider.value);
    
    setFeedSource(attributes.feedURL);
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Refresh feed if 15 minutes have passed since the last update
    var now = (new Date).getTime();
    if ((now - lastUpdated) > 15 * 60 * 1000) {
		updateDisplay();
	}
	document.getElementById("contentarea").focus();	
	
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");
		
	resizeWidget(320, 420);
	
    front.style.display="none";
    back.style.display="block";
	

    if (window.widget)
        setTimeout("widget.performTransition();", 0);
	
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
	var dimensions = widget.preferenceForKey('dimensions');
	if (dimensions) {
		dimensions = dimensions.split("x");
		resizeWidget(dimensions[0], dimensions[1]);
	} else {
		resizeWidget(490, 340);
	}
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    front.style.display = "block";
    back.style.display = "none";

    if (window.widget)
        setTimeout("widget.performTransition();", 0);
	
    refreshScrollArea();
}

// Initialize the Dashboard event handlers
if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}

//	
//	mouseDown()
//
//	Setup what's needed when we start resizing
//
function mouseDown(event)
{ 
    document.addEventListener("mousemove", mouseMove, true);
    document.addEventListener("mouseup", mouseUp, true);
 
    growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
 
    event.stopPropagation();
    event.preventDefault();
}

//	
//	mouseMove()
//
//	Used when you're resizing the widget
//
function mouseMove(event)
{
 
    x = event.x + growboxInset.x;
    y = event.y + growboxInset.y;
	
	if (x < 475) { x = 475; }
	if (y < 210) { y = 210; }
	
	resizeWidget(x, y);
	
    event.stopPropagation();
    event.preventDefault();
}

//
//	resizeWidget()
//
//	Resize the widget to specified coordinates
//	
function resizeWidget(x, y) {

	document.getElementById("resize").style.top = (y-12);
	document.getElementById('leftTile').style.height = (y - 140) + 'px';
	
    window.resizeTo(x,y);
	
	refreshScrollArea();
}
 
//
//	mouseUp()
//	
//	Mouse up used when you let go of resize handle
//
function mouseUp(event)
{
	//	We store these together because setPreferenceForKey
	//	only accepts strings--stupid.
	widget.setPreferenceForKey(x + 'x' + y, 'dimensions');
	
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true);
 
    event.stopPropagation();
    event.preventDefault();
}

//	
//	getToggle()
//
//	Get the current pane
//
function getToggle() {
	currentButton = widget.preferenceForKey('buttonPref');
	if (currentButton == 'popular') {
		return 'popular';
	} else {
		return 'recent';
	}
}

//
//	toggleButtons()
//
//	Used when switching between the popular and recent
//	tabs, also stores the current tab as a preference
//
function toggleButtons(button) {

	if (button) {
		widget.setPreferenceForKey(button, 'buttonPref');
	}
	
	recentButton	= document.getElementById('button-recent');
	popularButton	= document.getElementById('button-popular');
	currentButton	= widget.preferenceForKey('buttonPref');
	
	if (!currentButton) {
		widget.setPreferenceForKey('recent', 'buttonPref');
		currentButton	= 'recent';
	}
	
	if (currentButton == 'recent') {
		popularButton.style.backgroundImage = "url('images/mtw-popular-unselected.png')";
		recentButton.style.background = "url('images/mtw-recent-selected.png')";
	} else if (currentButton == 'popular') {
		popularButton.style.backgroundImage = "url('images/mtw-popular-selected.png')";
		recentButton.style.background = "url('images/mtw-recent-unselected.png')";
	}
	
	updateDisplay();
}

//
//	updateDisplay()
//
//	General function to update the display and
//	to reset our variables if we're switching panes
//
function updateDisplay() {

	//	This means we've changed from one display to the other
	if (lastButton != currentButton) {
		
		//	Let's reset the default values like page and search strings		
		recentPage		= 1;
		searchString	= "";
		document.getElementById('searchInput').value = '';
		
		lastButton		= currentButton;
				
		if (lastButton == 'recent') {
			goToRecentPage();
		} else {
			goToPopularPage();
		}
	}
}

//
//	goToHome()
//
//	Load the home page of MacTips
//
function goToHome() {
	widget.openURL('http://www.mactips.org');
}

//
//	doHand()
//
//	Change the cursor to a pointer
//
function doHand() {
	document.body.style.cursor = 'pointer';
}

//
//	doArrow()
//
//	Change the cursor back to the default arrow
//
function doArrow() {
	document.body.style.cursor = 'default';

}

//
//	loadLinkEffects()
//
//	Go through all the links and add a link class
//	so a hand appears when we hover over them
//
function loadLinkEffects() {
	var links = document.getElementsByTagName("a");
	for (var i = 0; i < links.length;i++) {
		links[i].setAttribute("class", links[i].className + " link");
	}


	
}